/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <unistd.h>

#include "aswvdial.h"
#include "../config.h"

int main(int argc, char **argv)
{
    connection = 0;
    entry = 0;
    maxentries = 0;

    wvdial.start = 0;
    wvdial.end = 0;
    wvdial.elapsed = 0.0;

    int c = 0;

    gai_init2(&applet_defines, &argc, &argv);

    if (0 == ReadConfig(&maxentries)) {
	return 1;
    }

    gai_signal_on_update((GaiCallback0 *)aswvdial_update, 1000, NULL);
    gai_signal_on_mouse_button_click((GaiCallback2 *)aswvdial_button1, GAI_MOUSE_BUTTON_1, NULL);

    connected_led = gai_load_image("connect_led.png");
    not_connected_led = gai_load_image("not_connected_led.png");
    background_connect =  gai_load_image("aswvdial_bg_connect.png");
    background = gai_load_image("aswvdial_bg.png");
    gai_background_from_gdkpixbuf(background, GAI_BACKGROUND_MAX_SIZE_IMAGE);

    gai_start();

    return 0;
}

/*
tag: 49d5e8cbdf6a89b2ec12fd764a1ab96cac6cecdd
*/

