/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "aswvdial.h"

void aswvdial_update(gpointer userdata)
{
	char* tooltip = NULL;
	char* time = NULL;
	int size = 0;

	if (ReadProc() == 1)
	{
	    time = Timing( 1, entry);
	    gai_draw( connected_led, 0, 0, 14, 11, 25, 2);
	}
	else
	{
	    time = Timing( 0, entry);
	    gai_draw( not_connected_led, 0, 0, 14, 11, 25, 2);
	}

	if (1 == connection)
	{
	    gai_draw_bg( background_connect, 0, 0, 64, 14, 0, 0);
	}
	else
	{
	    gai_draw_bg( background, 0, 0, 64, 14, 0, 0);
	}

	size = strlen(wvdial_opt[entry]) + strlen(time) + 2;
	tooltip = (char*) malloc( (size_t) size);
	(void) snprintf( tooltip, (size_t) size, "%s %s", wvdial_opt[entry], time);
	gai_tooltip_set( tooltip);

	gai_draw_update_bg();
	gai_draw_update();

	if (NULL != time) {
	    free( time);
	}
	if (NULL != tooltip) {
	    free( tooltip);
	}
}

void aswvdial_button1( int x, int y, gpointer userdata)
{
    char temp[57];

    /*mouse click on left button*/
    if (x>=1 && x<=20 && 0 == connection)
    {
	if(entry == 0)
	    entry = maxentries;
	else
	    entry = entry - 1;
    }

    /*mouse click on middle button*/
    if (x>=22 && x<=43)
    {
	if (0 == connection)
	{
	    connection = 1;
	    sprintf( temp, "netup %.50s", wvdial_opt[entry]);
	    if (system( temp) == -1)
		printf("\nError: Cannot execute wvdial\n");
	}
	else
	{
	    connection = 0;
	    if (system( "netdown") == -1)
		printf("\nError: Cannot close connection\n");
	}
    }

    /*mouse click on right button*/
    if (x>=45 && x<=64 && 0 == connection)
    {
	if (entry == maxentries)
	    entry = 0;
	else
	    entry = entry + 1;
    }
}

char* Timing(int start, int entry)
{
    double hours, minutes, seconds;
    static int starttimer = 1;
    int size = strlen( wvdial_opt[entry] + 1);
    char* result = (char *) malloc((size_t) 11);


    if (1 == start)
    {
        if (1 == starttimer)
        {
	    starttimer = 0;
	    wvdial.start = time(0);
	    (void) snprintf( wvdial.provider, (size_t) size, "%s", wvdial_opt[entry]);
	}
	wvdial.end=time(0);
	wvdial.elapsed=difftime(wvdial.end,wvdial.start);
    }
    else
    {
        if (0 == starttimer)
        {
	    starttimer = 1;
	    wvdial.end = time(0);
	    wvdial.elapsed = difftime( wvdial.end, wvdial.start);
	}
    }

    minutes = modf( wvdial.elapsed/3600, &hours);
    minutes = minutes * 60;
    seconds = modf( minutes, &minutes);
    seconds = seconds * 60;

    (void) snprintf( result, (size_t) 11, "(%2.0f:%2.0f:%2.0f)", hours, minutes, seconds);

    return result;
}

/*
tag: 2d6c0a1e59ca2dd98a1cb9c42b0ca1669bfb7c9d
*/

